function Bullet(x, y) {
  this.x = x;
  this.y = y;
  this.r = 8;
  this.toDelete = false; //to delete is initially set to false

  this.show = function () { //determines bullet's appearance 
    noStroke();
    fill(150, 0, 255);
    ellipse(this.x, this.y, this.r * 2, this.r * 2);
  }

  this.evaporate = function () { //when sketch.js uses evaporate function, to delete is set to true
    this.toDelete = true;
  }

  this.hitTargets = function (projectile) {
    var d = dist(this.x, this.y, projectile.x, projectile.y);
    if (d < this.r + projectile.r) {
      return true;
    } else {
      return false;
    }
  }

  this.hitBoss = function (boss) {
    var d = dist(this.x, this.y, boss.x, boss.y);
    if (d < this.r + (boss.r *2)) {
      return true;
    } else {
      return false;
    }
  }

  this.hitSphere = function (sphere){
    var d = dist(this.x, this.y, sphere.x, sphere.y);
    if (d < this.r + sphere.r) {
      return true;
    } else {
      return false;
    }
  }

  this.move = function () {
    this.y = this.y - 5; //determines speed of the bullet
  }

}
