var mc; //player, as in Main Character
var targets = []; //set array of targets
var bullets = []; //array of bullets
var enemies = []; //array of enemies
var sphere = []; // array of spheres
var health = 3; //set number of health points
//let level = 1;
var currentScene = 0; //number of scene

var lvlOneKill = 7; //number of targets needed to get shot before proceeding to next level
var bossHP = 50; //initial boss health points

let bulletsound; //variables for sound clips
let redspherewav;
let targexplode;
let gameoverjingle;
let winjingle;

function setup() {
  createCanvas(600, 500);
  getAudioContext().suspend();

  mc = new Player(); //creates player object

  for (var i = 0; i < 20; i++) {
    //creates array of maximum number of spheres
    sphere[i] = new drawBall();
  }
  //sphere = new drawBall();

  for (var i = 0; i < 7; i++) {
    targets[i] = new Target(i * 80 + 80, 60); //in brackets, placement and distance between targets
  }

  boss = new BossMan(300, 70); //creates boss objects
}

function draw() {
  switch (currentScene) {
    case 0: // Start Screen
      titleScreen();
      break;
    case 1: // Level 1 and UI
      runGame();
      levelOne();
      levelOneUI();
      console.log("Level 1 Kills: " + lvlOneKill); //for testing
      break;
    case 2: // Game Over Screen
      gameOver();
      break;
    case 3: // Level 2 and UI
      runGame();
      bossFight();
      bossUI();
      levelOneUI();
      break;
    case 4: // Finish Game Screen1
      winScreen();
      break;
  }
}

function preload() { //sets up file location for sounds
  bulletsound = loadSound("sounds/bulletshoot.wav");
  redspherewav = loadSound("sounds/red_sphee_shot.wav");
  targexplode = loadSound("sounds/target_explode.wav");
  winjingle = loadSound("sounds/winjingle.wav");
  gameoverjingle = loadSound("sounds/gameoverjingle.wav");
}

function titleScreen() {
  // Display Title Screen
  background(0);
  fill(255);
  textSize(75);
  textAlign(CENTER, CENTER);
  text("ORB SHOOTER", width / 2, 200);
  textSize(25);
  textAlign(CENTER, CENTER);
  text("Press 1 to start the game", width / 2, 260);
  textSize(15);
  text(
    "Press Left/ Right Arrow keys to move, Press Z to shoot",
    width / 2,
    300
  );
  text(
    "Destroy the Purple Spheres and Avoid shooting the Red Ones",
    width / 2,
    325
  );
}

function gameOver() {
  //DIsplay game over
  console.log("Game Over");

  background(0);
  fill(255);
  textSize(100);
  textAlign(CENTER, CENTER);
  text("GAME OVER", width / 2, height / 2);
  textSize(25);
  textAlign(CENTER, CENTER);
  text("Refresh the Page to Return to Title Screen", width / 2, 350);

  userStartAudio();
  gameoverjingle.play();
  noLoop(); //prevents jingle from looping
}

function winScreen() {
  //DIsplay game over
  console.log("Game Over");
  userStartAudio();
  winjingle.play();
  background(0);
  fill(255);
  textSize(100);
  textAlign(CENTER, CENTER);
  text("YOU WIN!", width / 2, height / 2);
  textSize(25);
  textAlign(CENTER, CENTER);
  text("The Boss is Dead", width / 2, 350);

  userStartAudio();
  winjingle.play();
  noLoop(); //prevents jingle from looping
}

function runGame() {
  // Base Controls
  background(51);
  mc.show(); //show and move player
  mc.move();

  //gameover, sends user to game over screen if health points reaches under 0
  if (health < 1) {
    currentScene = 2;
  }
}

function levelOneUI() {
  fill(255);
  textSize(25);
  textAlign(CENTER, CENTER);
  if (health == 3) {
    //updates the hp text everytime it goes down
    text("HP: 3", 40, 475);
  }
  if (health == 2) {
    text("HP: 2", 40, 475);
  }
  if (health == 1) {
    text("HP: 1", 40, 475);
  }
}

function bossUI() {
  //displays hp of the boss at the top of the screen
  //bossHP = 50;
  fill(255);
  textSize(25);
  textAlign(CENTER, CENTER);
  text(bossHP, 300, 50);
}

// Content of L E V E L  O N E ----------------------------------
function levelOne() {
  //bossHP = 50;

  for (var i = 0; i < 10; i++) {
    //displays, moves the 10 spheres, and allows them to bounce by bringing up the functions from their javascript files.
    sphere[i].show();
    sphere[i].move();
    sphere[i].bounce();
  }

  for (var i = 0; i < bullets.length; i++) {
    bullets[i].show(); //Showing bullets
    bullets[i].move();
    for (var j = 0; j < targets.length; j++) {
      if (bullets[i].hitTargets(targets[j])) {
        targets[j].shrink(); //Target deletes when hit
        bullets[i].evaporate();
        lvlOneKill = lvlOneKill - 1; //reduces number of "kills" when target gets shot by one
        console.log("lvlOneKill" + lvlOneKill);
        userStartAudio(); //audio plays
        targexplode.play();
      }
    }
    for (var j = 0; j < sphere.length; j++) {
      if (bullets[i].hitSphere(sphere[j])) {
        //bullets disappears when red sphere is shot
        bullets[i].evaporate();
        console.log("HIT RED DOTS");
        health = health - 1; //when red sphere is shot, it reduces the player's hp by one.
        userStartAudio();
        redspherewav.play();
      }
    }
  }

  var edge = false; //first sets if any of the purple targets' center are touching the edge of the screen as false

  for (var i = 0; i < targets.length; i++) {
    targets[i].show(); //showing and moving targets
    targets[i].move();
    if (targets[i].x > width || targets[i].x < 0) {
      edge = true; // checks if the targets' centers touch the edge
    }
  }

  for (var i = bullets.length - 1; i >= 0; i--) {
    if (bullets[i].toDelete) {
      bullets.splice(i, 1); //splice deletes the bullet from the array
    }
  }

  for (var j = targets.length - 1; j >= 0; j--) {
    if (targets[j].toDelete) {
      //refer to what happens when target is hit
      targets.splice(j, 1); //deletes one target from the array
    }
  }

  if (edge) {
    for (var i = 0; i < targets.length; i++) {
      targets[i].sidewards(); // makes targets change direction instead of moving off screen
    }
  }

  if (lvlOneKill == 0) {
    // Load level 2 when all targets are destroyed
    currentScene = 3;
  }
}

function bossFight() {
  console.log("HP: ", bossHP);

  var edge = false; //initially sets if the boss is touching the edge of the screen as false

  boss.show();
  boss.move(); //shows and moves the boss on screen

  if (boss.x > width || boss.x < 0) {
    edge = true; // checks if the boss' center is touching the edge of the screen
  }

  if (edge) {
    boss.sidewards(); // makes the boss change direction instead of moving off screen when edge is set to drew
  }

  for (var i = 0; i < bullets.length; i++) {
    bullets[i].show(); //Showing bullets and moving them
    bullets[i].move();
    if (bullets[i].hitBoss(boss)) {
      //checks if bullets hit the boss
      bullets[i].evaporate(); //bullets are deleted from the array
      bossHP = bossHP - 1; //reduces boss's HP by one when the bullet hits the boss
      userStartAudio();
      targexplode.play();
    }
  }

  for (var i = bullets.length - 1; i >= 0; i--) {
    if (bullets[i].toDelete) {
      bullets.splice(i, 1); //splice deletes the bullet from the array
    }
  }

  for (var i = 0; i < 15; i++) {
    sphere[i].show();
    sphere[i].move(); //displays, moves the 15 spheres, and allows them to bounce by bringing up the functions from their javascript files.
    sphere[i].bounce();
  }

  for (var i = 0; i < bullets.length; i++) {
    bullets[i].show(); //Showing bullets
    bullets[i].move(); //moving bullets
    for (var j = 0; j < sphere.length; j++) {
      if (bullets[i].hitSphere(sphere[j])) {
        //bullets disappear when a red sphere is shot
        bullets[i].evaporate();
        console.log("HIT RED DOTS");
        health = health - 1; //when red sphere is shot, it reduces the player's hp by one
        userStartAudio();
        redspherewav.play();
      }
    }
  }

  if (bossHP === 0) {
    //displays win screen when boss is defeated
    currentScene = 4;
  }
}

function keyPressed() {
  switch (
    currentScene //Enables keys to be pressed at each scene
  ) {
    case 0: // Start Screen
      if (keyCode == 49) {
        currentScene = 1;
      } else if (keyCode == 50) {
        currentScene = 3;
      }
      break;
    case 1: //  Controls for level 1
      if (key === "z") {
        // Shoot Bullet
        userStartAudio();
        bulletsound.play();
        var projectiles = new Bullet(mc.x, height);
        bullets.push(projectiles); //adds bulleys to the array
      }

      if (keyCode === RIGHT_ARROW) {
        // Going Right
        mc.setDir(1);
      } else if (keyCode === LEFT_ARROW) {
        //Left
        mc.setDir(-1);
      }

      //if (keyCode === 76) {
      //For testing --- Decrease health points
      //health = health - 1;
      //console.log(health);
      //}
      //if (keyCode === 82) {
      //For testing --- Increase health points
      //health = health + 1;
      //console.log("r is pressed");
      //}
      break;
    case 2: // Game Over screen ------------------------
      //if (keyCode === 49) {
      //For testing --- Increase health points
      //health = 3;
      //currentScene = 0;
      //}
      break;
    case 3: // Controls for Level 2, copy pasted for LV 1
      if (key === "z") {
        userStartAudio();
        bulletsound.play();
        var projectiles = new Bullet(mc.x, height);
        bullets.push(projectiles);
      }

      if (keyCode === RIGHT_ARROW) {
        mc.setDir(1);
      } else if (keyCode === LEFT_ARROW) {
        mc.setDir(-1);
      }

      //if (keyCode === 76) {
      //For testing --- Decrease health points
      //health = health - 1;
      //console.log(health);
      //}
      //if (keyCode === 82) {
      //For testing --- Increase health points
      //health = health + 1;
      //console.log("r is pressed");
      //}
      break;
  }
}

function keyReleased() {
  //stop player from moving when keys are released
  if (key != " ") {
    mc.setDir(0);
  }
}
